﻿# Define your animations here
image Marry Idle:
    Crop((32, 0, 32, 32), "press dance/Marry.png")
image Marry Down:
    Crop((0, 0, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 0, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((64, 0, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 0, 32, 32), "press dance/Marry.png")
    pause .2
    repeat
image Marry Left:
    Crop((0, 32, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 32, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((64, 32, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 32, 32, 32), "press dance/Marry.png")
    pause .2
    repeat
image Marry Right:
    Crop((0, 64, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 64, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((64, 64, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 64, 32, 32), "press dance/Marry.png")
    pause .2
    repeat
image Marry Up:
    Crop((0, 96, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 96, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((64, 96, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 96, 32, 32), "press dance/Marry.png")
    pause .2
    repeat
image Marry Mistake:
    Crop((32, 0, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 32, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 64, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 96, 32, 32), "press dance/Marry.png")
    pause .2
    repeat
init python:
    class press:
        def __init__(self, name, key, rot, x, y):
            self.name = name
            self.key = key
            self.left = 0
            self.rot = rot
            self.x = x
            self.y = y
        def pressed(self, g):
            if self.left:
                g.points += self.left
                msg3("+"+str(self.left))
                self.left = 0
                g.change(self.name)
            else:
                g.points -= 200
                msg4("-200")
                g.change("Mistake")
        def start(self, amount):
            self.left = amount
    class press_dance_handler:
        def __init__(self, name, parts = []):
            self.name = name
            self.parts = parts
            self.dancer = "Marry"
            self.move = "Idle"
            self.points = 0
            self.floor = 1

        def tick(self):
            for i in self.parts:
                if i.left > 0:
                    i.left -= 2
                    if i.left < 1:
                        i.left = 0
                        self.points -= 500
                        msg4("-500")
                        self.change("Mistake")
        def rand(self):
            r = renpy.random.choice(self.parts)
            if not r.left:
                r.left = renpy.random.randint(60, 260)
        def change(self, move):
            self.move = move
            if move == "Mistake":
                renpy.play("press dance/fail.ogg", "sound")
                self.floor = "red"
            else:
                renpy.play("press dance/success.ogg", "sound")
                self.floor = "green"
        def ground(self):
            r = renpy.random.randint(1,9)
            if not r == self.floor:
                self.floor = r
            else:
                self.ground()

default press_left = press(
    "Left",
    "a",
    0,
    -300, 0
)
default press_right = press(
    "Right",
    "d",
    180,
    300, 0
)
default press_up = press(
    "Up",
    "w",
    90,
    0, -300
)
default press_down = press(
    "Down",
    "s",
    -90,
    0, 300
)

default press_dance_1 = press_dance_handler(
    "Example",
    [
        press_left,
        press_right,
        press_up,
        press_down,
    ]
)

screen press_dance(g = press_dance_1):
    modal True
    timer .01 repeat True action Function(g.tick)
    timer 2 repeat True action Function(g.rand)
    timer .5 repeat True action Function(g.ground)
    add "#444"
    frame:
        align .5,.5 offset 160,-126 background None anchor 0.0,.5
        hbox:
            text _("Points: ") + str(g.points) size 24
    add "press dance/{}.png".format(g.floor) align .5,.5
    add "{} {}".format(g.dancer, g.move) align .5,.5 at press_zoom(4)
    for i in g.parts:
        button:
            at press_rot(i.rot)
            align .5,.5 xoffset i.x yoffset i.y
            action Function(i.pressed, g)
            fixed:
                fit_first True
                add "press dance/rail.png"
                if i.left:
                    vbox:
                        align .1,.5
                        add "press dance/arrow.png" xoffset i.left align .5,.5
        key i.key action Function(i.pressed, g)


transform press_rot(r):
    rotate_pad False
    rotate r

transform press_zoom(z):
    zoom z


